package LATMOS::Accounts::Web::Controller::Search::Adv;
use Moose;
use namespace::autoclean;

BEGIN { extends 'Catalyst::Controller'; }

=head1 NAME

LATMOS::Accounts::Web::Controller::Search::Adv - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index

=cut

sub index :Path :Args(0) {
    my ( $self, $c ) = @_;

    $c->stash->{db} = $c->model('Accounts')->db;

    if ($c->req->param('otype')) {
        $c->session->{searchOtype} = $c->req->param('otype');
    } elsif ($c->req->param('attr')) {
        push(@{$c->session->{searchValues}}, sprintf('%s~%s', $c->req->param('attr'), $c->req->param('attrval')));
    } elsif ($c->req->param('delval')) {
        my @delvals = $c->req->param('delval');
        my @newvals = ();
        foreach my $v (@{$c->session->{searchValues} || []}) {
            grep { $_ eq $v } @delvals and next;
            push(@newvals, $v);
        }
        $c->session->{searchValues} = \@newvals;
    } elsif(grep { $_ && $_ eq 'new' } $c->req->query_keywords) {
        $c->session->{searchOtype} = undef;
        $c->session->{searchValues} = [];
    }
    
    if ($c->session->{searchOtype}) {
        $c->stash->{objs} = [ $c->stash->{db}->search_objects(
            $c->session->{searchOtype},
            @{ $c->session->{searchValues} || []},
        ) ];
    }

}


=head1 AUTHOR

olivier

=head1 LICENSE

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

__PACKAGE__->meta->make_immutable;

1;
